#ifndef _H_D49E614E272B83C97CF7FAD6F592F065_Metadata_DCPS_H_
#define _H_D49E614E272B83C97CF7FAD6F592F065_Metadata_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Metadata_.h"


namespace ouster_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Metadata_TypeSupportInterface;

            typedef Metadata_TypeSupportInterface * Metadata_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Metadata_TypeSupportInterface> Metadata_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Metadata_TypeSupportInterface> Metadata_TypeSupportInterface_out;


            class Metadata_DataWriter;

            typedef Metadata_DataWriter * Metadata_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Metadata_DataWriter> Metadata_DataWriter_var;
            typedef DDS_DCPSInterface_out < Metadata_DataWriter> Metadata_DataWriter_out;


            class Metadata_DataReader;

            typedef Metadata_DataReader * Metadata_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Metadata_DataReader> Metadata_DataReader_var;
            typedef DDS_DCPSInterface_out < Metadata_DataReader> Metadata_DataReader_out;


            class Metadata_DataReaderView;

            typedef Metadata_DataReaderView * Metadata_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Metadata_DataReaderView> Metadata_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Metadata_DataReaderView> Metadata_DataReaderView_out;

            struct Metadata_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Metadata_, struct Metadata_Seq_uniq_> Metadata_Seq;
            typedef DDS_DCPSSequence_var < Metadata_Seq> Metadata_Seq_var;
            typedef DDS_DCPSSequence_out < Metadata_Seq> Metadata_Seq_out;

            class  Metadata_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Metadata_TypeSupportInterface_ptr _ptr_type;
                typedef Metadata_TypeSupportInterface_var _var_type;

                static Metadata_TypeSupportInterface_ptr _duplicate (Metadata_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Metadata_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Metadata_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Metadata_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Metadata_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Metadata_TypeSupportInterface () {};
                ~Metadata_TypeSupportInterface () {};
            private:
                Metadata_TypeSupportInterface (const Metadata_TypeSupportInterface &);
                Metadata_TypeSupportInterface & operator = (const Metadata_TypeSupportInterface &);
            };

            class  Metadata_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Metadata_DataWriter_ptr _ptr_type;
                typedef Metadata_DataWriter_var _var_type;

                static Metadata_DataWriter_ptr _duplicate (Metadata_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Metadata_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Metadata_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Metadata_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Metadata_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Metadata_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Metadata_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Metadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Metadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Metadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Metadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Metadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Metadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Metadata_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Metadata_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Metadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Metadata_& instance_data) = 0;

            protected:
                Metadata_DataWriter () {};
                ~Metadata_DataWriter () {};
            private:
                Metadata_DataWriter (const Metadata_DataWriter &);
                Metadata_DataWriter & operator = (const Metadata_DataWriter &);
            };

            class  Metadata_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Metadata_DataReader_ptr _ptr_type;
                typedef Metadata_DataReader_var _var_type;

                static Metadata_DataReader_ptr _duplicate (Metadata_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Metadata_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Metadata_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Metadata_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Metadata_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Metadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Metadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Metadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Metadata_& instance) = 0;

            protected:
                Metadata_DataReader () {};
                ~Metadata_DataReader () {};
            private:
                Metadata_DataReader (const Metadata_DataReader &);
                Metadata_DataReader & operator = (const Metadata_DataReader &);
            };

            class  Metadata_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Metadata_DataReaderView_ptr _ptr_type;
                typedef Metadata_DataReaderView_var _var_type;

                static Metadata_DataReaderView_ptr _duplicate (Metadata_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Metadata_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Metadata_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Metadata_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Metadata_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Metadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Metadata_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Metadata_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Metadata_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Metadata_& instance) = 0;

            protected:
                Metadata_DataReaderView () {};
                ~Metadata_DataReaderView () {};
            private:
                Metadata_DataReaderView (const Metadata_DataReaderView &);
                Metadata_DataReaderView & operator = (const Metadata_DataReaderView &);
            };
        }

    }

}

#endif
